Subject: RE: [hackers-il] YA Vim Trick: Indenting an Arbitrary Block

From: Chen Shapira <[email-masked]>
Date: Wed, 20 Feb 2002 13:18:54 +0200

> I find that the elegance and simplicity of the tools is very 
> important to me. I like my tools transparent and understandable, 
> and often I prefer not to use tools that do things too obscurely
> or too automatically, or that I have no chance to understand 
> (e.g., no source code and nontrivial implementation), for as long
> as more understandable tools exist, even if they are less 
> efficient. Is it only me, or do other members of the list feel 
> the same? Or is your choice of, e.g., Linux as a desktop system
> based on other factors? I'm suspecting that this might be what 
> differentiates a "user-mindset" from a "hacker-mindset" (whether 
> the person is a hacker or not). Either person might or might not
> be a programmer, but while a user desires functionality only from 
> tools, which are blackboxes, and demands elegance only from actual
> code they work with, a hacker-minded person makes no distinction
> between tools they write and code they work with -- nothing is
> truely a blackbox.

I believe it has nothing to do with hacker mindset.
It has to do with C programmer mindset :-)

I like high level languages, and even worse - high level databases.
Lets look at my favorite tool: Oracle.

Oracle is incredibly complex. Even if I had the source, nothing less than
MSC will allow me to understand how it works.
Yet, I'd never ever try to replace it. Man, I couldn't sort this fast no
matter what I did. And it can cache my requests for me! I don't have to
implement my own cache!

High level programmers (and shlomi can add his perl examples about nice
things that he don't need to worry about) enjoy having very very powerfull
tools so they can think about more complicated problems in a high-level way.

Sometimes a hashtable someone else implemented for me will be so
complicated, I won't have a chance to understand it. He may even hide the
code from me. Still, if its working efficiently (best if it promises some
sort of efficience in the interface, like STL does) and bug-free, its
sometimes much much better than a solution I'd understand.

I demand elegance from Interfaces. All else is optional.

---

From: Adi Stav <[email-masked]>
Date: Wed, 20 Feb 2002 18:12:18 +0200

> It has to do with C programmer mindset :-)

Perhaps, but not mine... I use high-level languages too when they fit 
the purpose, for as long as I understand how they think. 

> I demand elegance from Interfaces. All else is optional.

Damn, yet another attempt to define the hacker mindset goes in 
flames :) What an elusive concept... ("I'll know it when I see 
it")